SystemOrganization addCategory: #'ImageWriter-Tests'!

TestCase subclass: #HzFormatBaseTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ImageWriter-Tests'!

!HzFormatBaseTest class methodsFor: 'abstract' stamp: 'GuillermoPolito 4/26/2012 12:15'!
isAbstract
	^self == HzFormatBaseTest! !

!HzFormatBaseTest methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 4/26/2012 12:24'!
formatOf: anObject
	^(HzObjectFormat
		for: anObject
		withOopProvider: HzMockOopProvider
		withFormat: HzCogImageFormat new)! !

HzFormatBaseTest subclass: #HzObjectHeaderTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ImageWriter-Tests'!

!HzObjectHeaderTest methodsFor: 'large objects tests' stamp: 'GuillermoPolito 4/26/2012 12:10'!
testAmmountOfHeaderForLargeObject
	self
		assert: 3
		equals: (self formatOf: (Array new: 1000)) ammountOfHeaders! !

!HzObjectHeaderTest methodsFor: 'compact classes tests' stamp: 'GuillermoPolito 4/26/2012 12:12'!
testAmmountOfHeadersForCompactClasses
	{ 'hello I am a bytestring with size of 39' . self class >> #testAmmountOfHeadersForCompactClasses . 2.0 . thisContext copy . 2@5.2 }
		collect: [ :o | self formatOf: o ]
		thenDo: [ :f | 
			self assert: f ammountOfHeaders equals: 1.
			]! !

!HzObjectHeaderTest methodsFor: 'non compact non large tests' stamp: 'GuillermoPolito 4/26/2012 12:12'!
testAmmountOfHeadersForSimpleObject
	self assert: (self formatOf: Object new) ammountOfHeaders equals: 2! !

!HzObjectHeaderTest methodsFor: 'large objects tests' stamp: 'GuillermoPolito 4/26/2012 12:12'!
testTypeOfHeaderForLargeObject
	(self formatOf: (Array new: 1000)) headers do: [ :h |
		self assert: ((h valueFor: HzMockOopProvider) bitAnd: 3) equals: 0
		]! !

!HzObjectHeaderTest methodsFor: 'compact classes tests' stamp: 'GuillermoPolito 4/26/2012 12:13'!
testTypeOfHeadersForCompactClasses
	{ 'hello I am a bytestring with size of 39' . self class >> #testAmmountOfHeadersForCompactClasses . 2.0 . thisContext copy . 2@5.2 }
		collect: [ :o | self formatOf: o ]
		thenDo: [ :format | 
					format headers do: [ :h |
						self assert: ((h valueFor: HzMockOopProvider) bitAnd: 3) equals: 3
					]
			]! !

!HzObjectHeaderTest methodsFor: 'non compact non large tests' stamp: 'GuillermoPolito 4/26/2012 12:13'!
testTypeOfHeadersForSimpleObject
	(self formatOf: Object new) headers do: [ :h |
		self assert: ((h valueFor: HzMockOopProvider) bitAnd: 3) equals: 1
		]! !

HzFormatBaseTest subclass: #HzObjectSizeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ImageWriter-Tests'!

!HzObjectSizeTest methodsFor: 'bytes classes tests' stamp: 'GuillermoPolito 4/26/2012 12:13'!
testByteStringBodySize
	self assert: (self formatOf: 'hello I am a bytestring with size of 39')
					bodyLength == (10 "words for the string with one last empty byte" + 1 "word for the baseHeader")! !

!HzObjectSizeTest methodsFor: 'bytes classes tests' stamp: 'GuillermoPolito 4/26/2012 12:13'!
testByteSymbolBodySize
	self assert: (self formatOf: #'hello I am a bytestring with size of 39')
					bodyLength == (10 "words for the string with one last empty byte" + 1 "word for the baseHeader")! !

!HzObjectSizeTest methodsFor: 'special classes tests' stamp: 'GuillermoPolito 4/26/2012 12:14'!
testCompiledMethodBodySize
	| method |
	method := self class >> #testCompiledMethodBodySize.
	self assert: (self formatOf: method) 
					bodyLength == (0 "words for the slots" + (method basicSize roundUpTo: 4 "bytes")/4 "words for the method" + 1 "word for the base header")! !

!HzObjectSizeTest methodsFor: 'bit classes tests' stamp: 'GuillermoPolito 4/26/2012 12:14'!
testFloatSize
	self assert: (self formatOf: 2.0)
					bodyLength == (2 "words for the slots" + 1 "word for the baseHeader")! !

!HzObjectSizeTest methodsFor: 'special classes tests' stamp: 'GuillermoPolito 4/26/2012 12:13'!
testMethodContextBodySize
	| contextCopy |
	self flag: #todo. "we have to test also the large frames but i don't know how to get one".
	
	contextCopy := thisContext copy.
	self assert: (self formatOf: contextCopy) bodyLength == (contextCopy class instSize "words for the slots" + 16 "words for the context frame" + 1 "word for the base header")! !

!HzObjectSizeTest methodsFor: 'pointer classes tests' stamp: 'GuillermoPolito 4/26/2012 12:13'!
testPointBodySize
	self assert: (self formatOf: 1@2.5) bodyLength == (2 "words for the slots" + 1 "word for the baseHeader")! !

HzFormatBaseTest subclass: #HzSmallIntegerOopTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ImageWriter-Tests'!

!HzSmallIntegerOopTest methodsFor: 'tests' stamp: 'GuillermoPolito 4/26/2012 12:09'!
testPositiveSmallIntegerOop
	self assert: (500 << 1) + 1 "this last bit flat indicates it is a small integer" equals: (HzSmallIntegerObjectFormat new object: 500) oop! !

Object subclass: #HzMockOopProvider
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ImageWriter-Tests'!

!HzMockOopProvider class methodsFor: 'mock' stamp: 'GuillermoPolito 4/26/2012 12:13'!
oopForObject: anObject
	^744 "its an oop, supposed to be a memory address"! !

!HzMockOopProvider class methodsFor: 'mock' stamp: 'GuillermoPolito 4/25/2012 19:54'!
reserve: anObject from: anotherObject field: anIndex
	^744 "its an oop, supposed to be a memory address"! !
